Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3382)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3418)
@@ -7949,31 +9682,50 @@
                                      f_shf * surf_usm_v(l)%pt1(m) +            &
                                      lambda_surface_window * t_window_v(l)%t(nzb_wall,m)
-
+endif
+           IF ( (humidity).and.(surf_usm_v(l)%frac(ind_pav_green,m).gt.0.0_wp) )  THEN
               coef_green_1 = surf_usm_v(l)%rad_net_l(m) +                      & ! coef +1 corresponds to -lwout included in calculation of radnet_l
-              ( 3.0_wp + 1.0_wp ) * surf_usm_v(l)%emissivity(ind_pav_green,m) *&
-                                     sigma_sb * t_surf_green_v(l)%t(m) ** 4 +  &  
+               ( 3.0_wp + 1.0_wp ) * surf_usm_v(l)%emissivity(ind_pav_green,m) * sigma_sb *  &
+                                     t_surf_green_v(l)%t(m) ** 4 +               &  
+                                     f_shf * surf_usm_v(l)%pt1(m) +     f_qsws * ( qv1 - q_s    &
+                                          + dq_s_dt * t_surf_green_v(l)%t(m) ) +            &
+                                     lambda_surface_green * t_wall_v(l)%t(nzb_wall,m)
+           ELSE
+              coef_green_1 = surf_usm_v(l)%rad_net_l(m) +                        & ! coef +1 corresponds to -lwout included in calculation of radnet_l
+               ( 3.0_wp + 1.0_wp ) * surf_usm_v(l)%emissivity(ind_pav_green,m) * sigma_sb *  &
+                                     t_surf_green_v(l)%t(m) ** 4 +               &  
                                      f_shf * surf_usm_v(l)%pt1(m) +            &
                                      lambda_surface_green * t_wall_v(l)%t(nzb_wall,m)
+           ENDIF
+                                     
 
 !--           denominator of the prognostic equation
-              coef_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_veg_wall,m) *     &
-                                sigma_sb * t_surf_v(l)%t(m) ** 3               &
-                              + lambda_surface + f_shf / exner(k)
-              coef_window_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_wat_win,m) *&
-                                sigma_sb * t_surf_window_v(l)%t(m) ** 3        &
+              coef_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_veg_wall,m) * sigma_sb *           &
+                                t_surf_wall_v(l)%t(m) ** 3                           &
+                              + lambda_surface + f_shf / exner(k)  
+if ((.NOT. spinup).AND.(surf_usm_v(l)%frac(ind_wat_win,m).GT.0.0_wp)) then             
+              coef_window_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_wat_win,m) * sigma_sb *           &
+                                t_surf_window_v(l)%t(m) ** 3                         &
                               + lambda_surface_window + f_shf / exner(k)
-              coef_green_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_pav_green,m) *&
-                                sigma_sb * t_surf_green_v(l)%t(m) ** 3         &
+endif
+           IF ( (humidity).and.(surf_usm_v(l)%frac(ind_pav_green,m).gt.0.0_wp) )  THEN
+               coef_green_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_pav_green,m) * sigma_sb *     &
+                                t_surf_green_v(l)%t(m) ** 3  + f_qsws * dq_s_dt      &
                               + lambda_surface_green + f_shf / exner(k)
+           ELSE
+              coef_green_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_pav_green,m) * sigma_sb *     &
+                                t_surf_green_v(l)%t(m) ** 3                          &
+                              + lambda_surface_green + f_shf / exner(k)
+           ENDIF
 
 !--           implicit solution when the surface layer has no heat capacity,
 !--           otherwise use RK3 scheme.
-              t_surf_v_p(l)%t(m) = ( coef_1 * dt_3d * tsc(2) +                 &
-                             surf_usm_v(l)%c_surface(m) * t_surf_v(l)%t(m) ) / & 
+              t_surf_wall_v_p(l)%t(m) = ( coef_1 * dt_3d * tsc(2) +                 &
+                             surf_usm_v(l)%c_surface(m) * t_surf_wall_v(l)%t(m) ) / & 
                            ( surf_usm_v(l)%c_surface(m) + coef_2 * dt_3d * tsc(2) ) 
+if ((.NOT. spinup).AND.(surf_usm_v(l)%frac(ind_wat_win,m).GT.0.0_wp)) then
               t_surf_window_v_p(l)%t(m) = ( coef_window_1 * dt_3d * tsc(2) +                 &
                              surf_usm_v(l)%c_surface_window(m) * t_surf_window_v(l)%t(m) ) / & 
                            ( surf_usm_v(l)%c_surface_window(m) + coef_window_2 * dt_3d * tsc(2) ) 
-
+endif
               t_surf_green_v_p(l)%t(m) = ( coef_green_1 * dt_3d * tsc(2) +                 &
                              surf_usm_v(l)%c_surface_green(m) * t_surf_green_v(l)%t(m) ) / & 
@@ -7981,6 +9733,6 @@
 
 !--           add RK3 term
-              t_surf_v_p(l)%t(m) = t_surf_v_p(l)%t(m) + dt_3d * tsc(3) *                   &
-                                surf_usm_v(l)%tt_surface_m(m)
+              t_surf_wall_v_p(l)%t(m) = t_surf_wall_v_p(l)%t(m) + dt_3d * tsc(3) *         &
+                                surf_usm_v(l)%tt_surface_wall_m(m)
               t_surf_window_v_p(l)%t(m) = t_surf_window_v_p(l)%t(m) + dt_3d * tsc(3) *     &
                                 surf_usm_v(l)%tt_surface_window_m(m)
@@ -7991,6 +9743,6 @@
 !--           store also vpt_surface, which is, due to the lack of moisture on roofs simply
 !--           assumed to be the surface temperature.     
-              surf_usm_v(l)%pt_surface(m) =  ( surf_usm_v(l)%frac(ind_veg_wall,m) * t_surf_v_p(l)%t(m)   &
-                                      + surf_usm_v(l)%frac(ind_wat_win,m) * t_surf_window_v_p(l)%t(m)    &
+              surf_usm_v(l)%pt_surface(m) =  ( surf_usm_v(l)%frac(ind_veg_wall,m) * t_surf_wall_v_p(l)%t(m)  &
+                                      + surf_usm_v(l)%frac(ind_wat_win,m) * t_surf_window_v_p(l)%t(m)  &
                                       + surf_usm_v(l)%frac(ind_pav_green,m) * t_surf_green_v_p(l)%t(m) ) &
                                       / exner(k)
@@ -8000,6 +9752,6 @@
 
 !--           calculate true tendency
-              stend = ( t_surf_v_p(l)%t(m) - t_surf_v(l)%t(m) - dt_3d * tsc(3) *&
-                        surf_usm_v(l)%tt_surface_m(m) ) / ( dt_3d  * tsc(2) )
+              stend_wall = ( t_surf_wall_v_p(l)%t(m) - t_surf_wall_v(l)%t(m) - dt_3d * tsc(3) *&
+                        surf_usm_v(l)%tt_surface_wall_m(m) ) / ( dt_3d  * tsc(2) )
               stend_window = ( t_surf_window_v_p(l)%t(m) - t_surf_window_v(l)%t(m) - dt_3d * tsc(3) *&
                         surf_usm_v(l)%tt_surface_window_m(m) ) / ( dt_3d  * tsc(2) )
@@ -8007,14 +9759,14 @@
                         surf_usm_v(l)%tt_surface_green_m(m) ) / ( dt_3d  * tsc(2) )
 
-!--           calculate t_surf tendencies for the next Runge-Kutta step
+!--           calculate t_surf_* tendencies for the next Runge-Kutta step
               IF ( timestep_scheme(1:5) == 'runge' )  THEN
                  IF ( intermediate_timestep_count == 1 )  THEN
-                    surf_usm_v(l)%tt_surface_m(m) = stend
+                    surf_usm_v(l)%tt_surface_wall_m(m) = stend_wall
                     surf_usm_v(l)%tt_surface_window_m(m) = stend_window
                     surf_usm_v(l)%tt_surface_green_m(m) = stend_green
                  ELSEIF ( intermediate_timestep_count <                                 &
                           intermediate_timestep_count_max )  THEN
-                    surf_usm_v(l)%tt_surface_m(m) = -9.5625_wp * stend +                &
-                                     5.3125_wp * surf_usm_v(l)%tt_surface_m(m)
+                    surf_usm_v(l)%tt_surface_wall_m(m) = -9.5625_wp * stend_wall +      &
+                                     5.3125_wp * surf_usm_v(l)%tt_surface_wall_m(m)
                     surf_usm_v(l)%tt_surface_green_m(m) = -9.5625_wp * stend_green +    &
                                      5.3125_wp * surf_usm_v(l)%tt_surface_green_m(m)
@@ -8027,8 +9779,8 @@
 !--           update the radiative fluxes in order to keep the solution stable
 
-              IF ( ( ( ABS( t_surf_v_p(l)%t(m) - t_surf_v(l)%t(m) ) > 1.0_wp ) .OR.            &
-                   ( ABS( t_surf_green_v_p(l)%t(m) - t_surf_green_v(l)%t(m) ) > 1.0_wp ) .OR.  &
-                   ( ABS( t_surf_window_v_p(l)%t(m) - t_surf_window_v(l)%t(m) ) > 1.0_wp ) )   &
-                     .AND.  unscheduled_radiation_calls ) THEN
+              IF ( ( ( ABS( t_surf_wall_v_p(l)%t(m)   - t_surf_wall_v(l)%t(m) )   > 1.0_wp ) .OR. &
+                   (   ABS( t_surf_green_v_p(l)%t(m)  - t_surf_green_v(l)%t(m) )  > 1.0_wp ) .OR. &
+                   (   ABS( t_surf_window_v_p(l)%t(m) - t_surf_window_v(l)%t(m) ) > 1.0_wp ) )    &
+                      .AND.  unscheduled_radiation_calls )  THEN
                  force_radiation_call_l = .TRUE.
               ENDIF
@@ -8039,6 +9791,6 @@
                                            ( surf_usm_v(l)%rad_net_l(m) +                            &
                                            3.0_wp * sigma_sb *                                       &
-                                           t_surf_v(l)%t(m)**4 - 4.0_wp * sigma_sb *                 &
-                                           t_surf_v(l)%t(m)**3 * t_surf_v_p(l)%t(m) )                &
+                                           t_surf_wall_v(l)%t(m)**4 - 4.0_wp * sigma_sb *                 &
+                                           t_surf_wall_v(l)%t(m)**3 * t_surf_wall_v_p(l)%t(m) )                &
                                          + surf_usm_v(l)%frac(ind_wat_win,m) *                       &
                                            ( surf_usm_v(l)%rad_net_l(m) +                            &
@@ -8055,5 +9807,5 @@
                                                 ( t_surf_window_v_p(l)%t(m) - t_window_v(l)%t(nzb_wall,m) )
               surf_usm_v(l)%wghf_eb(m)   = lambda_surface *                    &
-                                     ( t_surf_v_p(l)%t(m) - t_wall_v(l)%t(nzb_wall,m) )
+                                     ( t_surf_wall_v_p(l)%t(m) - t_wall_v(l)%t(nzb_wall,m) )
               surf_usm_v(l)%wghf_eb_green(m)  = lambda_surface_green *  &
                                                 ( t_surf_green_v_p(l)%t(m) - t_green_v(l)%t(nzb_wall,m) )
@@ -8062,5 +9814,5 @@
               surf_usm_v(l)%wshf_eb(m)   =                                     &
                  - f_shf  * ( surf_usm_v(l)%pt1(m) -                           &
-                 t_surf_v_p(l)%t(m) / exner(k) ) * surf_usm_v(l)%frac(ind_veg_wall,m)       &
+                 t_surf_wall_v_p(l)%t(m) / exner(k) ) * surf_usm_v(l)%frac(ind_veg_wall,m)       &
                  - f_shf_window  * ( surf_usm_v(l)%pt1(m) -                    &
                  t_surf_window_v_p(l)%t(m) / exner(k) ) * surf_usm_v(l)%frac(ind_wat_win,m)&
@@ -8072,4 +9824,69 @@
 !--           diffusion_s, surface_layer_fluxes,...
               surf_usm_v(l)%shf(m) = surf_usm_v(l)%wshf_eb(m) / c_p
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+if (surf_usm_v(l)%frac(ind_pav_green,m).gt.0.0_wp) then !111
+
+! print*, "tsurfroofgreen",m,t_surf_green_h_p(m),i,j,k,surf_usm_h%wghf_eb_green(m),surf_usm_h%rad_net_l(m),&
+!         surf_usm_h%wshf_eb(m),f_qsws_veg,f_qsws_liq,dq_s_dt
+! print*, "B",surf_usm_h%rad_sw_in(m),surf_usm_h%rad_sw_out(m),surf_usm_h%rad_lw_in(m),surf_usm_h%rad_lw_out(m)
+! print*, "lambdasurface",lambda_surface_green,lambda_surface,i,j,k
+! print*, "fractions",i,j,k,surf_usm_h%frac(0:2,m)
+if ((t_surf_green_v_p(l)%t(m).gt.370.0_wp).or.(t_surf_green_v_p(l)%t(m).lt.250.0_wp)) then
+  print*, t_surf_green_v_p(l)%t(m),m,i,j,k
+  stop
+endif
+
+       IF ( humidity )  THEN
+          surf_usm_v(l)%qsws_eb(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt                     &
+                          * t_surf_green_v(l)%t(m) - dq_s_dt *               &
+                            t_surf_green_v_p(l)%t(m) )
+
+          surf_usm_v(l)%qsws(m) = surf_usm_v(l)%qsws_eb(m) / rho_lv
+
+          surf_usm_v(l)%qsws_veg_eb(m)  = - f_qsws_veg  * ( qv1 - q_s                      &
+                              + dq_s_dt * t_surf_green_v(l)%t(m) - dq_s_dt   &
+                              * t_surf_green_v_p(l)%t(m) )
+
+!           surf_usm_h%qsws_liq_eb(m)  = - f_qsws_liq  * ( qv1 - q_s                      &
+!                               + dq_s_dt * t_surf_green_h(m) - dq_s_dt   &
+!                               * t_surf_green_h_p(m) )
+       ENDIF
+
+!
+!--    Calculate the true surface resistance
+       IF ( .NOT.  humidity )  THEN
+          surf_usm_v(l)%r_s(m) = 1.0E10_wp
+       ELSE
+          surf_usm_v(l)%r_s(m) = - rho_lv * ( qv1 - q_s + dq_s_dt                       &
+                          *  t_surf_green_v(l)%t(m) - dq_s_dt *               &
+                            t_surf_green_v_p(l)%t(m) ) /                     &
+                            (surf_usm_v(l)%qsws(m) + 1.0E-20)  - surf_usm_v(l)%r_a(m)
+       ENDIF
+
+       
+!
+!--    Calculate change in liquid water reservoir due to dew fall or 
+!--    evaporation of liquid water
+       IF ( humidity )  THEN
+!
+!--       If the air is saturated, check the reservoir water level
+          IF ( surf_usm_v(l)%qsws(m) < 0.0_wp )  THEN
+       
+!
+!--          In case qsws_veg becomes negative (unphysical behavior), 
+!--          let the water enter the liquid water reservoir as dew on the
+!--          plant
+             IF ( surf_usm_v(l)%qsws_veg_eb(m) < 0.0_wp )  THEN
+!                 surf_usm_h%qsws_liq_eb(m) = surf_usm_h%qsws_liq_eb(m) + surf_usm_h%qsws_veg_eb(m)
+                surf_usm_v(l)%qsws_veg_eb(m) = 0.0_wp
+             ENDIF
+          ENDIF   
+    ENDIF
+else
+  surf_usm_v(l)%r_s(m) = 1.0E10_wp
+endif !111
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
 
            ENDDO
@@ -8130,4 +9947,106 @@
        ENDIF
 
+! !
+! !-- Calculate surface specific humidity
+!     IF ( humidity )  THEN
+!        CALL calc_q_surface_usm
+!     ENDIF
+
+
+    CONTAINS
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculation of specific humidity of the skin layer (surface). It is assumend
+!> that the skin is always saturated.
+!------------------------------------------------------------------------------!
+       SUBROUTINE calc_q_surface_usm
+
+          IMPLICIT NONE
+
+          REAL(wp) :: resistance    !< aerodynamic and soil resistance term
+
+          DO  m = 1, surf_usm_h%ns
+
+             i   = surf_usm_h%i(m)            
+             j   = surf_usm_h%j(m)
+             k   = surf_usm_h%k(m)
+
+!
+!--          Calculate water vapour pressure at saturation
+             e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp *                  &
+                                    ( t_surf_green_h_p(m) - 273.16_wp ) /  &
+                                    ( t_surf_green_h_p(m) - 35.86_wp  )    &
+                                         )
+
+!
+!--          Calculate specific humidity at saturation
+             q_s = 0.622_wp * e_s / ( surface_pressure - e_s )
+
+!              surf_usm_h%r_a_green(m) = ( surf_usm_h%pt1(m) - t_surf_green_h(m) / exner(k) ) /                  &
+!                    ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-10_wp )
+!                 
+! !--          make sure that the resistance does not drop to zero
+!              IF ( ABS(surf_usm_h%r_a_green(m)) < 1.0E-10_wp )  surf_usm_h%r_a_green(m) = 1.0E-10_wp
+
+             resistance = surf_usm_h%r_a_green(m) / ( surf_usm_h%r_a_green(m) + surf_usm_h%r_s(m) + 1E-5_wp )
+
+!
+!--          Calculate specific humidity at surface
+             IF ( bulk_cloud_model )  THEN
+                q(k,j,i) = resistance * q_s +                   &
+                                           ( 1.0_wp - resistance ) *              &
+                                           ( q(k,j,i) - ql(k,j,i) )
+             ELSE
+                q(k,j,i) = resistance * q_s +                   &
+                                           ( 1.0_wp - resistance ) *              &
+                                             q(k,j,i)
+             ENDIF
+
+!
+!--          Update virtual potential temperature
+             vpt(k,j,i) = pt(k,j,i) *         &
+                        ( 1.0_wp + 0.61_wp * q(k,j,i) )
+
+          ENDDO
+
+!--       Now, treat vertical surface elements
+          DO  l = 0, 3
+             DO  m = 1, surf_usm_v(l)%ns
+!
+!--             Get indices of respective grid point
+                i = surf_usm_v(l)%i(m)
+                j = surf_usm_v(l)%j(m)
+                k = surf_usm_v(l)%k(m)
+
+!
+!--             Calculate water vapour pressure at saturation
+                e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp *                       &
+                                       ( t_surf_green_v_p(l)%t(m) - 273.16_wp ) /  &
+                                       ( t_surf_green_v_p(l)%t(m) - 35.86_wp  )    &
+                                            )
+
+!
+!--             Calculate specific humidity at saturation
+                q_s = 0.622_wp * e_s / ( surface_pressure -e_s )
+
+!
+!--             Calculate specific humidity at surface
+                IF ( bulk_cloud_model )  THEN
+                   q(k,j,i) = ( q(k,j,i) - ql(k,j,i) )
+                ELSE
+                   q(k,j,i) = q(k,j,i)
+                ENDIF
+!
+!--             Update virtual potential temperature
+                vpt(k,j,i) = pt(k,j,i) *         &
+                           ( 1.0_wp + 0.61_wp * q(k,j,i) )
+
+             ENDDO
+
+          ENDDO
+
+       END SUBROUTINE calc_q_surface_usm
+       
     END SUBROUTINE usm_surface_energy_balance
 
@@ -8146,7 +10065,7 @@
       
 #if defined( __nopointer )
-       t_surf_h    = t_surf_h_p
+       t_surf_wall_h    = t_surf_wall_h_p
        t_wall_h    = t_wall_h_p
-       t_surf_v    = t_surf_v_p
+       t_surf_wall_v    = t_surf_wall_v_p
        t_wall_v    = t_wall_v_p
        t_surf_window_h    = t_surf_window_h_p
@@ -8163,5 +10082,5 @@
 !
 !--          Horizontal surfaces
-             t_surf_h  => t_surf_h_1; t_surf_h_p  => t_surf_h_2
+             t_surf_wall_h  => t_surf_wall_h_1; t_surf_wall_h_p  => t_surf_wall_h_2
              t_wall_h     => t_wall_h_1;    t_wall_h_p     => t_wall_h_2
              t_surf_window_h  => t_surf_window_h_1; t_surf_window_h_p  => t_surf_window_h_2
@@ -8171,5 +10090,5 @@
 !
 !--          Vertical surfaces
-             t_surf_v  => t_surf_v_1; t_surf_v_p  => t_surf_v_2
+             t_surf_wall_v  => t_surf_wall_v_1; t_surf_wall_v_p  => t_surf_wall_v_2
              t_wall_v     => t_wall_v_1;    t_wall_v_p     => t_wall_v_2
              t_surf_window_v  => t_surf_window_v_1; t_surf_window_v_p  => t_surf_window_v_2
@@ -8180,5 +10099,5 @@
 !
 !--          Horizontal surfaces
-             t_surf_h  => t_surf_h_2; t_surf_h_p  => t_surf_h_1
+             t_surf_wall_h  => t_surf_wall_h_2; t_surf_wall_h_p  => t_surf_wall_h_1
              t_wall_h     => t_wall_h_2;    t_wall_h_p     => t_wall_h_1
              t_surf_window_h  => t_surf_window_h_2; t_surf_window_h_p  => t_surf_window_h_1
@@ -8188,5 +10107,5 @@
 !
 !--          Vertical surfaces
-             t_surf_v  => t_surf_v_2; t_surf_v_p  => t_surf_v_1
+             t_surf_wall_v  => t_surf_wall_v_2; t_surf_wall_v_p  => t_surf_wall_v_1
              t_wall_v     => t_wall_v_2;    t_wall_v_p     => t_wall_v_1
              t_surf_window_v  => t_surf_window_v_2; t_surf_window_v_p  => t_surf_window_v_1
@@ -8224,6 +10143,6 @@
        WRITE ( 14 )  surf_usm_h%end_index
 
-       CALL wrd_write_string( 't_surf_h' )
-       WRITE ( 14 )  t_surf_h
+       CALL wrd_write_string( 't_surf_wall_h' )
+       WRITE ( 14 )  t_surf_wall_h
 
        CALL wrd_write_string( 't_surf_window_h' )
@@ -8243,6 +10162,6 @@
           WRITE( dum, '(I1)')  l          
 
-          CALL wrd_write_string( 't_surf_v(' // dum // ')' )
-          WRITE ( 14 )  t_surf_v(l)%t
+          CALL wrd_write_string( 't_surf_wall_v(' // dum // ')' )
+          WRITE ( 14 )  t_surf_wall_v(l)%t
 
           CALL wrd_write_string( 't_surf_window_v(' // dum // ')' )
